   
    
;****************************************************************************************
;*                           LUFTFEUCHTIGKEITS-SENSOR DHT22 VON DL3UKH                  *
;*                           =========================================                  *
;*                                                                                      *
;*                                   01.11.22 BEGIN                                     *
;*                                   05.11.22 ENDE                                      *    
;****************************************************************************************


    LIST    P=PIC16F1827
 
    ;TITLE   "LUFTFEUCHTIGKEIT"

    ERRORLEVEL -302
    INCLUDE <P16F1827.INC>

;--------------------------------------------------------------------------

;ALS OSZILLATOR INTERN 32MHZ  (T=0.03125S T:=TAKTZEIT)

;--------------------------------------------------------------------------
 
 __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _IESO_OFF & 0X3FFF
 __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _BORV_HI & _LVP_OFF & 0X3FFF
           
;-------------------------------------------------------------------------

;-------------------------------------------------------------------------

;------------------------------------------------------------------------- 
;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7
        
;--------------------------------------------------------------------------         
;-------------------------------------------------------------------------- 
;HIER KANN MAN AENDERN :
;ZAHLEN BZW. SEC VON 1 BIS 255 SIND MOEGLICH
;MINIMALE ZEIT IST 2SEC LAUT DATENBLATT 
;AUS SICHERHEITS-GRUENDEN 10SEC GENOMMEN /// SO MISST ES AUCH GENAUER LAUT DATENBLATT        
        
MESS_INTERVALL      EQU D'10'   ;ALLER 10 SEC ERFOLGT EINE MESSUNG
  
;-------------------------------------------------------------------------- 
;--------------------------------------------------------------------------        
LCD_STELLE          EQU 0XC9    ;FUER LCD-STELLE % RF UND C          
    
STELLE              EQU 0XC9    ;FUER LCD-STELLE DIE RECHTE KLEINSTE ZAHL          
;-------------------------------------------------------------------------- 
;--------------------------------------------------------------------------
;PINS KURZ-SCHREIBWEISE / ZUORDNUNG        
SDO2       EQU 0   ;RA0 AUSGANG / FUER SPI LCD
SCK2       EQU 5   ;RB5 AUSGANG / FUER SPI LCD
CS         EQU 3   ;RA3 AUSGANG / FUER SPI LCD       
RS         EQU 2   ;RA2 AUSGANG / FUER LCD  OB BEFEHL ODER DATEN

SDA        EQU 1   ;RB1 EINGANG / AUSGANG -- SENSOR
         
TASTER     EQU 0   ;RB0 EINGANG
       
;------------ MACROS FUER INTERRUPT -----------------------------------------

PUSH    MACRO
        MOVWF   W_STACK
        MOVF    STATUS, W
        MOVWF   S_STACK
        ENDM
;----------------------------------------------------------------------------

POP     MACRO
        MOVF    S_STACK, W
        MOVWF   STATUS
        SWAPF   W_STACK, F
        SWAPF   W_STACK, W
        ENDM
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 21 HEX LOS
;ALSO DIE RAM-SPEICHER ZUORDNUNG

;FUER MERK-ZELLE
MERK            EQU 0X21         
MERK1           EQU 0X22
           
;FUER ZEITSCHLEIFEN         
HELP            EQU 0X23
HELP1           EQU 0X24
HELP2           EQU 0X25           
           
;SPI-DATEN 
DAT             EQU 0X26

;RX-DATEN
DATT            EQU 0X27
ZAE             EQU 0X28
IMPULS_ZEIT     EQU 0X29
     
;MESSWERTE AUSGELESEN
HEX_DAT_LUFT_L  EQU 0X2A
HEX_DAT_LUFT_H  EQU 0X2B  
HEX_DAT_TEMP_L  EQU 0X2C
HEX_DAT_TEMP_H  EQU 0X2D
  
;SCHALTEN MIT TASTER
MODE            EQU 0X2E
PRELL           EQU 0X2F
           
;HEX-ZU-BCD            
;EINGABE HEX-BYTE            
EINGABE_BYTE01  EQU 0X30
EINGABE_BYTE02  EQU 0X31
EINGABE_BYTE03  EQU 0X32
           
;ERGEBNIS BYTES / ALSO BCD-BYTES WIE BCD21=0X37 IST DEZ.: 37 
BCD21           EQU 0X33           
BCD43           EQU 0X34
BCD65           EQU 0X35       

;HILFS-BYTES FUER HEX-BCD            
ZAE_D0          EQU 0X36
ZAE_D01         EQU 0X37  
ZAE_D02         EQU 0X38             
VER             EQU 0X39

;BCD ANZEIGEN
;BCD21       EQU 0X01 ;SCHON OBEN           
;BCD43       EQU 0X02
;BCD65       EQU 0X03    
NULL_AUSB       EQU 0X3A       
MERKER          EQU 0X3B
VORZ_STELLE     EQU 0X3C
VORZ_JA         EQU 0X3D    ;AUS BERECHNUNGS-PROGRAMM UEBERNEHMEN ;BEI BIT0=HIGH MIT VORZEICHEN ALS MINUS "-"
      
;EEPROM
ADR             EQU 0X3E
                 
;FUER INTERRUPT       
S_STACK         EQU 0X3F
W_STACK         EQU 0X40
 
;FEHLER ZAEHLEN   ;KEIN FEHLER AUFGETRETEN BEI INTERVALL-MESSUNG 1SEC
;FEHLER          EQU 0X41
          
          
;--------------------------------------------------------------------------
;SPEICHERANFANG BZW. BEGINN

    ORG 0X0000
    GOTO MAIN       ;SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT 


    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG USW...
MAIN                    MOVLB   D'0'        ;BANK0
                        CLRF    PORTA     
                        CLRF    PORTB
                        
                        MOVLB   D'2'        ;BANK2
                        CLRF    LATA                    ;ALLES DATA-LATCH
                        CLRF    LATB
                        
                        ;MOVLW   D'2'             ;PIN-ZUORDNUNG FUER SPI UND I2C VERAENDERN  /// HIER NICHT GEMACHT
                        ;MOVWF   APFCON0
                        ;MOVWF   APFCON1
                        
                        MOVLB   D'1'        ;BANK1
                        MOVLW   B'11110010'             ;RA0... ALLE BENUTZTEN RA0_2_3 ALS AUSGANG (ALSO HIER DIE 0) AUSGANG FUER SPI
                        MOVWF   TRISA
                        MOVLW   B'11011111'             ;RB0... ALLES ALS EINGANG (ALSO HIER DIE 1) 
                                                        ;NUR RB5 ALS AUSGANG (ALSO HIER DIE 0) FR SCK2 [FUER SPI]
                        MOVWF   TRISB
                        
;FR DEN INTERNEN OSZILLATOR 8MHZ /// HOLE ABER EINSTELLUNGEN AUS CONFIG INTERN "OBEN" UND PLL*4 /// DANN 32MHZ
                        MOVLW   B'11110000' ;B'01110110'  ;JETZT 4MHZ INTERN OHNE PLL*4                
                        MOVWF   OSCCON
                        
;INIT TIMER 0 FUER ZEITSCHLEIFE
                        MOVLW   B'10000111'             ;BIT0-2 000=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG 
                        BCF     OPTION_REG, INTEDG      ;BEI FALLENDER FLANKE VON +5V ZU NULL --> INTERRUPT
                        
                        MOVLB   D'3'        ;BANK3
                        CLRF    ANSELA                  ;ALLES I/O PINS AM PORTS KEIN ANALOG
                        CLRF    ANSELB
                        
                        MOVLB   D'4'        ;BANK4   
                        CLRF    WPUA                    ;ALLES KEIN PULL-UP
                        CLRF    WPUB

                        MOVLW   D'50'                   ;ZEITSCHLEIFE
                        CALL    ZS1MSEC
      
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SPI2 INITIALISIERUNG                         
                        CLRF    SSP2STAT  ;IST SCHON ALS GRUNDEINSTELLUNG         ;BIT7=0 (IN DER MITTE AUF DER AUSGABE OUTPUT) // NUR NOCH BIT6 SCHREIBBAR -HAT ALS LOW FUNKTIONIERT
                                                        
                                                        
                        MOVLW   B'00010010'            
                                                       ;BIT5=0 SPI-PORTS DISABLE // BIT4=1 FUER HIGH LEVEL MODE-1,1 // AUSGABEFREQUENZ BIT0-3 = 0000 FOSC:4 MAXIMALE AUSGEBE-FREQUENZ GING BEIM DISPLAY NICHT
                                                       ;JETZT KEINE MAX AUSGABE-FREQUENZ FOSZ:64 ALS 0010 -->NUR ZUR SICHERHEIT DIE KLEINSTE AUSGABE-FREQUENZ
                        MOVWF   SSP2CON1                
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                        
                        
                        MOVLB   D'0'         ;BANK0
                        BSF     PORTA, CS    ;CS VON SPI NICHT AKTIV 

;LCD-MODUL DOGM162 INITIALISIERUNG FUER +5,0VOLT
LCD         MOVLW   D'2'
            MOVWF   MERK

;INITIALISIERUNG DOT-MATRIX-LCD
            MOVLW   H'39'                   ;FUNCTION SET  8-BIT-LAENGE, 2-ZEILIG
            CALL    BEFEHL
 
INIT        MOVLW   H'14'  ;NICHT H'1C' WICHTIG -- HAT EINS HOEHER POSITIONIERT            ;BIAS SET
            CALL    BEFEHL
 
            MOVLW   H'52'  ;                ;POWER CONTROL
            CALL    BEFEHL
 
            MOVLW   H'6A'  ;                ;FOLLOWER CONTROL
            CALL    BEFEHL
 
            MOVLW   H'74'  ;                ;CONTRAST SET
            CALL    BEFEHL

            MOVLW   H'38'                   ;FUNCTION SET  8-BIT-LAENGE, 2-ZEILIG
            CALL    BEFEHL
 
            DECFSZ  MERK, F
            GOTO    INIT  

            
            MOVLW   H'0C'                   ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
            CALL    BEFEHL
            
            CLRF    BCD21         
            CLRF    BCD43
            CLRF    BCD65
            
            CLRF    HEX_DAT_LUFT_H
            CLRF    HEX_DAT_LUFT_L
            CLRF    HEX_DAT_TEMP_H
            CLRF    HEX_DAT_TEMP_L
            
;;;;;;;;;;;;;;;;;;;;;;;;
;IST SCHON ETWAS GESPEICHERT ???
            MOVLW   0X00
            MOVWF   ADR
            CALL    E_READ
            SUBLW   0XFF
            BTFSS   STATUS, Z
            GOTO    ALT01         ;ES IST SCHON ETWAS GESPEICHERT
 
;ALS LUFTFEUCHTIGKEIT ZU BEGINN ALS ERSTES SPEICHERN
            BSF     MODE, BIT0    ;ES IST NOCH NICHTS GESPEICHERT
            CLRF    ADR
            MOVF    MODE, W
            CALL    E_WRITE
            
            CALL    LOESCHEN
            CALL    LUFTFEUCHTIGKEIT
            CALL    FEUCHTIGKEIT
            BCF     VORZ_JA, BIT0
            CALL    BCD_ANZEIGE
            GOTO    WEITER01
            
ALT01       CLRF    ADR
            CALL    E_READ
            MOVWF   MODE
            
            BTFSS   MODE, BIT0
            GOTO    WEITER02
            
            CALL    LOESCHEN
            CALL    LUFTFEUCHTIGKEIT
            CALL    FEUCHTIGKEIT
            BCF     VORZ_JA, BIT0
            CALL    BCD_ANZEIGE
            GOTO    WEITER01
            
WEITER02    CALL    LOESCHEN
            CALL    TEMPERATUR
            CALL    CELSIUS
            BCF     VORZ_JA, BIT0
            CALL    BCD_ANZEIGE
            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;           
;INITIALISIERUNG INTERRUPT AN RB0

;NUR FUER RB0 INTERRUPT ZULASSEN
            
WEITER01        BSF     INTCON, PEIE        ;INTERUPT ZULASSEN PEREPHERIE / 
                                            ;WEIS NICHT OB ES DRIN SEIN MUSS / WAHRSCHEINLICH JA
                BSF     INTCON, INTE        ;INTERRUPT EXTERNAL VON RB0 ZULASSEN
                BCF     INTCON, IOCIF       ;INTERRUPT FR EXTERNEN PIN NICHT ZULASSEN MIT CHANGE VON RB0 AUF EINGANG!!!
                BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                BSF     INTCON, GIE         ;ALLGEMEINES INTERRUPT ENABLE 
            
            
;INITIALISIERUNG ZU ENDE
            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            
               
BEGINN01             
;PUNKT FUER 300MSEC ALS "GEMESSEN" DARSTELLEN            
            MOVLW   H'CF'                   
            CALL    BEFEHL
            MOVLW   "."
            CALL    DATEN
            
            MOVLW   D'150'      ;ZEITSCHLEIFE 300MSEC
            CALL    ZS1MSEC
            MOVLW   D'150'
            CALL    ZS1MSEC
            
            MOVLW   H'CF'                   
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN
              
        BSF     INTCON, GIE     ;INTERRUPT EIN
            
            MOVLW   MESS_INTERVALL       ;15SEC ZEITSCHLEIFE /// SIEHE OBEN VEREINBARUNG EINSTELLBAR
            CALL    ZS1SEC
                  
;;;;MESSEN
LL1     BCF     INTCON, GIE     ;INTERRUPT SPERREN // MUSS SO GEMACHT WERDEN!!! // NICHT NUR --> BCF  INTCON, GIE
        BTFSC   INTCON, GIE
        GOTO    LL1
        
LL2         CALL    START
            
;BEI FEHLER ALSO VERKLEMMT            
            MOVF    MERK1, W
            SUBLW   D'0'
            BTFSS   STATUS, Z
            GOTO    NO_VERKLEMMT
            
;NOCH MAL START NACH 1MIN
            MOVLW   D'60'
            CALL    ZS1SEC
            GOTO    LL2
            
NO_VERKLEMMT
            CALL    RX
            MOVWF   HEX_DAT_LUFT_H

            CALL    RX
            MOVWF   HEX_DAT_LUFT_L
            
            CALL    RX
            MOVWF   HEX_DAT_TEMP_H
            
            CALL    RX
            MOVWF   HEX_DAT_TEMP_L
          
                BTFSS   MODE, BIT0              ;ACHTUNG
                GOTO    BEGINN02
                
                CALL    LOESCHEN
                CALL    LUFTFEUCHTIGKEIT
                CALL    FEUCHTIGKEIT
                MOVF    HEX_DAT_LUFT_H, W
                MOVWF   EINGABE_BYTE02
                MOVF    HEX_DAT_LUFT_L, W
                MOVWF   EINGABE_BYTE01
                
    MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
 
                CALL    HEX_ZU_BCD
                
    MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
 
                BCF     VORZ_JA, BIT0
                CALL    BCD_ANZEIGE
                GOTO    BEGINN01
                
BEGINN02        CALL    LOESCHEN
                CALL    TEMPERATUR
                CALL    CELSIUS
                MOVF    HEX_DAT_TEMP_H, W
                MOVWF   EINGABE_BYTE02
                MOVF    HEX_DAT_TEMP_L, W
                MOVWF   EINGABE_BYTE01 
                
;BEI MINUS TEMPERATUREN                
            BCF     VORZ_JA, BIT0
            BTFSS   HEX_DAT_TEMP_H, BIT7
            GOTO    BEGINN03
            BSF     VORZ_JA, BIT0
            BCF     EINGABE_BYTE02, BIT7
            BCF     EINGABE_BYTE02, BIT6
            BCF     EINGABE_BYTE02, BIT5
            BCF     EINGABE_BYTE02, BIT4
            BCF     EINGABE_BYTE02, BIT3
            BCF     EINGABE_BYTE02, BIT2
            
BEGINN03            
    MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
 
                CALL    HEX_ZU_BCD
                
    MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
 
                CALL    BCD_ANZEIGE
                GOTO    BEGINN01


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    
;*****************************************************************************
;*                              INTERRUPT                                    *
;*****************************************************************************
INTERRUPT       PUSH

                BTFSC   MODE, BIT0
                GOTO    INT0A
                
                BSF     MODE, BIT0
                CLRF    ADR
                MOVF    MODE, W
                CALL    E_WRITE
                
                CALL    LOESCHEN
                CALL    LUFTFEUCHTIGKEIT
                CALL    FEUCHTIGKEIT
                MOVF    HEX_DAT_LUFT_H, W
                MOVWF   EINGABE_BYTE02
                MOVF    HEX_DAT_LUFT_L, W
                MOVWF   EINGABE_BYTE01 
                
    MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
 
                CALL    HEX_ZU_BCD
                
    MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
 
                BCF     VORZ_JA, BIT0
                CALL    BCD_ANZEIGE
                GOTO    INT04
                
INT0A           BCF     MODE, BIT0
                CLRF    ADR
                MOVF    MODE, W
                CALL    E_WRITE
                
                CALL    LOESCHEN
                CALL    TEMPERATUR
                CALL    CELSIUS
                MOVF    HEX_DAT_TEMP_H, W
                MOVWF   EINGABE_BYTE02
                MOVF    HEX_DAT_TEMP_L, W
                MOVWF   EINGABE_BYTE01 
                
;BEI MINUS TEMPERATUREN                
            BCF     VORZ_JA, BIT0
            BTFSS   HEX_DAT_TEMP_H, BIT7
            GOTO    BEGINN_INT
            BSF     VORZ_JA, BIT0
            BCF     EINGABE_BYTE02, BIT7
            BCF     EINGABE_BYTE02, BIT6
            BCF     EINGABE_BYTE02, BIT5
            BCF     EINGABE_BYTE02, BIT4
            BCF     EINGABE_BYTE02, BIT3
            BCF     EINGABE_BYTE02, BIT2
 
BEGINN_INT            
    MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
 
                CALL    HEX_ZU_BCD
                
    MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
 
                CALL    BCD_ANZEIGE
                
INT04           MOVLW   D'200' ;GESAMT: 30MSEC ENTPRELLEN
                MOVWF   PRELL
                BTFSS   PORTB, TASTER
                GOTO    INT04
                
INT03           MOVLW   D'150' ;150SEC // 0,15MSEC
                CALL    ZS1MUESEC
                BTFSS   PORTB, TASTER
                GOTO    INT04
                DECFSZ  PRELL, F
                GOTO    INT03
                
INT01           BCF     INTCON, INTF    ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT 
                                        ;JETZT AUF JEDEN FALL HIER LSCHEN

                POP
                RETFIE

;*****************************************************************************
;*                             START-IMPULS                                  *
;*****************************************************************************
START
;ALS AUSGANG /// ES WIRD GESENDET VOM CONTROLLER
                        MOVLB   D'1'             ; BANK1
                        BCF     TRISB, SDA       ; ALS AUSGANG
                        MOVLB   D'0'             ; BANK0

                        ;BSF     PORTB, SDA      ;MUSS NICHT SEIN
                        ;MOVLW   D'100'          ;100SEC HIGH HALTEN
                        ;CALL    ZS1MUESEC
                        
                        MOVLW   D'5'            ;1000SEC LOW IMPULS
                        MOVWF   MERK1
                        BCF     PORTB, SDA
                        
START01                 MOVLW   D'200'
                        CALL    ZS1MUESEC
                        
                        DECFSZ  MERK1, F
                        GOTO    START01
                        
                        BSF     PORTB, SDA      ;30SEC HIGH IMPULS
                        MOVLW   D'30'
                        CALL    ZS1MUESEC
                        BCF     PORTB, SDA     
                        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;RESPONSE (ANTWORT VOM SENSOR)
;ALS EINGANG 
                        MOVLB   D'1'             ; BANK1
                        BSF     TRISB, SDA       ; ALS EINGANG
                        MOVLB   D'0'             ; BANK0
                        
START02                 BTFSS   PORTB, SDA       ;KONTROLL NACHFRAGE
                        GOTO    START02          ;GLEICH ZU HIGH-IMPULS  // LOW-IMPULS KEINE AUSWERTUNG
                        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;1.                        
;MESSEN DER ANTWORT ALS LOW-IMPULS
;ACHTUNG: WIRD NICHT AUSGEWERTET !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!                        
                        
;                        CLRF    MERK1
                        
;START04                 NOP
;                        NOP                     ;ZWEI NOP = 0.03125SEC *4 = 0.125SEC--> 2NOPS *0.125SEC = 0.250SEC
;                        INCFSZ  MERK1, F        ;0.125SEC
;                        GOTO    START03         ;0.250SEC
;                        ;CLRF    MERK1          ;UEBERLAUF-MERKER /// MUSS NICHT SEIN, DA SOWIESO NULL
;                        RETURN                  ;UEBERLAUF-FEHLER
;START03                 BTFSS   PORTB, SDA      ;0.125SEC
;                        GOTO    START04         ;0.250SEC      GESAMT: 1.0SEC
                        
;LOW-IMPULS GRENZEN AUSWERTEN --> GROESSER 75SEC UND KLEINER 85SEC // ANDERE GRENZEN GENOMMEN ZUR SICHERHEIT
;                        MOVF    MERK1, W
;                        SUBLW   D'70'
;                        BTFSC   STATUS, C
;                        GOTO    FEHLER_START
                        
;                        MOVF    MERK1, W
;                        SUBLW   D'90'
;                        BTFSS   STATUS, C
;                        GOTO    FEHLER_START
                        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;2.                        
;MESSEN DER ANTWORT ALS HIGH-IMPULS
                        
                        CLRF    MERK1
                        
START04X                NOP
                        NOP                     ;ZWEI NOP = 0.03125SEC *4 = 0.125SEC--> 2NOPS *0.125SEC = 0.250SEC
                        INCFSZ  MERK1, F        ;0.125SEC
                        GOTO    START03X        ;0.250SEC
                        ;CLRF    MERK1          ;UEBERLAUF-MERKER /// MUSS NICHT SEIN, DA SOWIESO NULL
                        RETURN                  ;UEBERLAUF-FEHLER
START03X                BTFSC   PORTB, SDA      ;0.125SEC
                        GOTO    START04X        ;0.250SEC      GESAMT: 1.0SEC
                        
;HIGH-IMPULS GRENZEN AUSWERTEN --> GROESSER 75SEC UND KLEINER 85SEC // ANDERE GRENZEN GENOMMEN NUR ZUR SICHERHEIT
                        MOVF    MERK1, W
                        SUBLW   D'70'
                        BTFSC   STATUS, C
                        GOTO    FEHLER_START
                        
                        MOVF    MERK1, W
                        SUBLW   D'90'
                        BTFSS   STATUS, C
                        GOTO    FEHLER_START
                        
                        RETURN
               
                        
FEHLER_START            CLRF    MERK1
                        RETURN 
 
 
;*****************************************************************************
;*                            EIN BYTE EMPFANGEN                             *
;*                            ERGEBNIS IN W                                  *                        
;*****************************************************************************
RX
                        MOVLW   D'8'
                        MOVWF   ZAE
                        
                        CLRF    DATT
                        
RX02                    RLF     DATT, F
                        
                        MOVLW   D'50'       ;BEI GROESSER 50SEC IST DAS BIT HIGH
                        MOVWF   IMPULS_ZEIT
                        
RX01                    BTFSS   PORTB, SDA
                        GOTO    RX01
                        
RX03                    NOP                 ;NOP = 0.03125SEC *4 = 0.125SEC--> 8NOPS *0.125SEC = 1.0SEC
                        NOP
                        NOP
                        ;NOP
                        
                        ;NOP
                        ;NOP                ;WEGGEMACHT WEGEN ZEIT VON DECFSZ UND GOTO_RX03 UND BTFSS
                        ;NOP
                        ;NOP
                        
                        BTFSS   PORTB, SDA
                        GOTO    RX_AUSWERTUNG
                        
                        DECFSZ  IMPULS_ZEIT ;KANN BEI HIGH-IMPULS NOCH HIGH SEIN
                        GOTO    RX03
;ALS HIGH
                        BSF     DATT, BIT0
;ALS LOW                        
RX_AUSWERTUNG           DECFSZ  ZAE, F      ;KANN BEI HIGH-IMPULS NOCH HIGH SEIN
                        GOTO    RX_AUS02    ;KANN BEI HIGH-IMPULS NOCH HIGH SEIN
                                         
RX_AUS01                BTFSC   PORTB, SDA
                        GOTO    RX_AUS01
                        
                        MOVF    DATT, W
                        RETURN
                        
;KANN BEI HIGH-IMPULS NOCH HIGH SEIN
RX_AUS02                BTFSC   PORTB, SDA
                        GOTO    RX_AUS02
                        GOTO    RX02
       
            

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                               
;*****************************************************************************
;*                             SPI EIN                                       *
;*****************************************************************************
EIN_SPI
;                        ;ALS AUSGANG  // SCHON IN INITALISIERUNG OBEN
;                        ;MOVLB   D'1'        ;BANK1
;                        ;BCF     TRISA, SDO2
;                        ;BCF     TRISB, SCK2
                        
                        MOVLB   D'4'                ;BANK4   
                        BSF    SSP2CON1, SSPEN      ;BIT5=1 SPI-PORTS ENABLE
                        MOVLB   D'0'                ;BANK0
                        RETURN
               
;*****************************************************************************
;*                             SPI AUS                                       *
;*****************************************************************************
AUS_SPI               
;                        ;ALS EINGANG  // SCHON IN INITALISIERUNG OBEN ALS AUSGANG // SO AUCH STAENDIG LASSEN
;                        ;MOVLB   D'1'        ;BANK1
;                        ;BSF     TRISA, SDO2
;                        ;BSF     TRISB, SCK2
                        
                        MOVLB   D'4'                ;BANK4               
                        BCF    SSP2CON1, SSPEN      ;BIT5=1 SPI-PORTS DISABLE
                        MOVLB   D'0'                ;BANK0               
                        RETURN
  
;*****************************************************************************
;*                              UNTERPROG. DATEN AUSGEBEN AUF DOT-LCD-MODUL  *
;*****************************************************************************
DATEN       MOVWF   DAT
            BSF     PORTA, RS               ;ALS DATEN
              CALL    EIN_SPI
            MOVLW   D'10'
            CALL    ZS1MUESEC               ;MUSS SEIN LCD-MODUL TRAEGE RS PIN REAGIERT NICHT SOFORT
                                            ;DESHALB ZEITSCHLEIFE
                        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;DATEN SPI-AUSGABE                                                                        
                        BCF     PORTA, CS    ;CS AKTIV
                        
                        BCF     PIR4, SSP2IF ;MUSS SEIN !

                        MOVF    DAT, W
                        MOVLB   D'4'        ;BANK4
                        MOVWF   SSP2BUF
                        MOVLB   D'0'        ;BANK0
                        
WARTE01                 BTFSS   PIR4, SSP2IF
                        GOTO    WARTE01
                        
                        BSF     PORTA, CS    ;CS NICHT AKTIV                         
;;;;;;;;;;;;;;
                          CALL    AUS_SPI
                          
                        MOVLW   D'10'       ;50SEC
                        CALL    ZS1MUESEC
                        RETURN
                        
;*****************************************************************************
;*                              UNTERPROG. BEFEHL AUSGEBEN AUF DOT-LCD-MODUL *
;*****************************************************************************
BEFEHL      MOVWF   DAT
            BCF     PORTA, RS               ;ALS BEFEHL            
              CALL    EIN_SPI
            MOVLW   D'10'
            CALL    ZS1MUESEC               ;MUSS SEIN LCD-MODUL TRAEGE RS PIN REAGIERT NICHT SOFORT
                                            ;DESHALB ZEITSCHLEIFE
                        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;DATEN SPI-AUSGABE                                                                        
                        BCF     PORTA, CS    ;CS AKTIV
                        
                        BCF     PIR4, SSP2IF ;MUSS SEIN !
                        
                        MOVF    DAT, W
                        MOVLB   D'4'        ;BANK4
                        MOVWF   SSP2BUF
                        MOVLB   D'0'        ;BANK0
                        
WARTE02                 BTFSS   PIR4, SSP2IF
                        GOTO    WARTE02
                        
                        BSF     PORTA, CS    ;CS NICHT AKTIV                         
;;;;;;;;;;;;;;
                          CALL    AUS_SPI
                          
                        MOVLW   D'10'       ;50SEC
                        CALL    ZS1MUESEC
                        RETURN 

;*****************************************************************************
;*                            ZEITSCHLEIFE  CA. X-MAL 1SEC                  *
;*****************************************************************************
ZS1MUESEC
    MOVWF   HELP
ZZS01
    NOP ;EIN NOP = 0.03125SEC *4 = 0.125SEC  (1SEC : 0.125SEC = 8 STCK. NOPS)
    NOP
    NOP
    NOP
    NOP
    
    ;NOP
    ;NOP        ;WEGGEMACHT WEGEN ZEIT VON DECFSZ UND GOTO
    ;NOP
 
    DECFSZ  HELP, F
    GOTO    ZZS01
    RETURN    

;MIT 8XNOP(T=4) GESAMT(T=32) 32*0,03125SEC=1SEC

;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 1MSEC                      *
;*****************************************************************************                   
ZS1MSEC                 MOVWF   HELP

Z01                     MOVLW   D'225'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                 
Z02                     BTFSS   INTCON, TMR0IF            
                        GOTO    Z02                    
                      
                        DECFSZ  HELP, F
                        GOTO    Z01
                        
                        RETURN

;ZEITBERECHNUNG FUER 1MSEC
;PRESCALER 256X  +  SYSTEM 4X  ====> 256*4*0.03125SEC=32SEC
;1MSEC:32SEC=31,25 GENOMMEN 31    
;TMR0 ALSO D'256'-D'31'=D'225' ENTSPRICHT CA. 1MSEC
;225 DEZIMAL OBEN EINTRAGEN
             
;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 1SEC                       *
;*****************************************************************************                   
ZS1SEC           
                        MOVWF   HELP2
                        
XZZZ0A                  MOVLW   D'10'                   ;FUER 1SEC
                        MOVWF   HELP1

XZZZ03                  MOVLW   D'20'                   ;FUER 100MSEC
                        MOVWF   HELP
                        
XZZZ01                  MOVLW   D'100'                  ;FUER 5MSEC
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                 
XZZZ02                  BTFSS   INTCON, TMR0IF            
                        GOTO    XZZZ02
                                                
XZZZ04                  DECFSZ  HELP, F                
                        GOTO    XZZZ01                    
                        
                        DECFSZ  HELP1, F
                        GOTO    XZZZ03
                        
                        DECFSZ  HELP2, F
                        GOTO    XZZZ0A
                        RETURN      
                                         
;*****************************************************************************
;*                             DOT-LCD-MODUL TEXT LOESCHEN                   *
;*****************************************************************************
LOESCHEN
            MOVLW   H'01'
            CALL    BEFEHL
            
            MOVLW   D'5'
            CALL    ZS1MSEC
            RETURN                     
            
;*****************************************************************************
;*                              TEXT AUF DOT-LCD-MODUL AUSGEBEN              *
;*****************************************************************************
LUFTFEUCHTIGKEIT
            MOVLW   H'80'                   
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'81'                   
            CALL    BEFEHL
            MOVLW   0X75 ;U
            CALL    DATEN

            MOVLW   H'82'                   
            CALL    BEFEHL
            MOVLW   0X66 ;F
            CALL    DATEN

            MOVLW   H'83'                   
            CALL    BEFEHL
            MOVLW   0X74 ;T
            CALL    DATEN
                                    
            MOVLW   H'84'                   
            CALL    BEFEHL
            MOVLW   0X66 ;F                    
            CALL    DATEN
                                    
            MOVLW   H'85'                   
            CALL    BEFEHL
            MOVLW   0X65 ;E                    
            CALL    DATEN
                                    
            MOVLW   H'86'                   
            CALL    BEFEHL
            MOVLW   0X75 ;U                    
            CALL    DATEN
                                    
            MOVLW   H'87'                   
            CALL    BEFEHL
            MOVLW   0X63 ;C                    
            CALL    DATEN
                                    
            MOVLW   H'88'                   
            CALL    BEFEHL
            MOVLW   0X68 ;H                    
            CALL    DATEN
                                    
            MOVLW   H'89'                   
            CALL    BEFEHL
            MOVLW   0X74 ;T                    
            CALL    DATEN
                                    
            MOVLW   H'8A'                   
            CALL    BEFEHL
            MOVLW   0X69 ;I                    
            CALL    DATEN
                                    
            MOVLW   H'8B'                   
            CALL    BEFEHL
            MOVLW   0X67 ;G                    
            CALL    DATEN
                                    
            MOVLW   H'8C'                   
            CALL    BEFEHL
            MOVLW   0X6B ;K                    
            CALL    DATEN
                                    
            MOVLW   H'8D'                   
            CALL    BEFEHL
            MOVLW   0X65 ;E                    
            CALL    DATEN
                                    
            MOVLW   H'8E'                   
            CALL    BEFEHL
            MOVLW   0X69 ;I                    
            CALL    DATEN
                                    
            MOVLW   H'8F'                   
            CALL    BEFEHL
            MOVLW   0X74 ;T                    
            CALL    DATEN
            
            RETURN
                           
;*****************************************************************************
;*                              TEXT AUF DOT-LCD-MODUL AUSGEBEN              *
;*****************************************************************************
TEMPERATUR
            MOVLW   H'83'                   
            CALL    BEFEHL
            MOVLW   "T"
            CALL    DATEN

            MOVLW   H'84'                   
            CALL    BEFEHL
            MOVLW   0X65 ;E
            CALL    DATEN

            MOVLW   H'85'                   
            CALL    BEFEHL
            MOVLW   0X6D ;M
            CALL    DATEN

            MOVLW   H'86'                   
            CALL    BEFEHL
            MOVLW   0X70 ;P
            CALL    DATEN
                                    
            MOVLW   H'87'                   
            CALL    BEFEHL
            MOVLW   0X65 ;E                    
            CALL    DATEN
                                    
            MOVLW   H'88'                   
            CALL    BEFEHL
            MOVLW   0X72 ;R                    
            CALL    DATEN
                                    
            MOVLW   H'89'                   
            CALL    BEFEHL
            MOVLW   0X61 ;A                    
            CALL    DATEN
                                    
            MOVLW   H'8A'                   
            CALL    BEFEHL
            MOVLW   0X74 ;T                    
            CALL    DATEN
                                    
            MOVLW   H'8B'                   
            CALL    BEFEHL
            MOVLW   0X75 ;U                    
            CALL    DATEN
                                    
            MOVLW   H'8C'                   
            CALL    BEFEHL
            MOVLW   0X72 ;R                    
            CALL    DATEN
            
            RETURN
            
;*****************************************************************************
;*                              TEXT AUF DOT-LCD-MODUL AUSGEBEN              *
;*****************************************************************************
CELSIUS          
            MOVLW   LCD_STELLE+1                 
            CALL    BEFEHL
            MOVLW   0XDF ;                    
            CALL    DATEN
            
            MOVLW   LCD_STELLE+2
            CALL    BEFEHL
            MOVLW   "C"                    
            CALL    DATEN
                      
            RETURN         
                              
            
;*****************************************************************************
;*                              TEXT AUF DOT-LCD-MODUL AUSGEBEN              *
;*****************************************************************************
FEUCHTIGKEIT           
            MOVLW   LCD_STELLE+1
            CALL    BEFEHL
            MOVLW   0X25 ;%                    
            CALL    DATEN
            
            MOVLW   LCD_STELLE+2                   
            CALL    BEFEHL
            MOVLW   " "                    
            CALL    DATEN
             
            MOVLW   LCD_STELLE+3                  
            CALL    BEFEHL
            MOVLW   0X72 ;R
            CALL    DATEN
            
            MOVLW   LCD_STELLE+4
            CALL    BEFEHL
            MOVLW   "F"                    
            CALL    DATEN
                              
            RETURN         

;*******************************************************************************
;*                       BCD-ANZEIGE AUS 16-BIT-HEX LAENGE                     *
;*******************************************************************************
; ANZEIGE-STELLEN     ...... / 4+3-STELLE ALS BYTE BCD43 / 2+1-STELLE ALS BYTE BCD21
;
; 16BIT = HEX FF_FF =  DEZ 06 55 35  DIES SIND 6 STELLEN / DIES SIND 3BYTE ALS BCD...21 43 56  SIEHE UNTEN
;
; ANZEIGE ERFOLGT SO --> 6553.5 
;
; VORNULLEN WEG AB 1,23     ALSO NICHT 01,23    AUCH NICHT NULL LOESCHEN 0,12          
;
; ALS RECHTE LCD STELLE GILT      STELLE EQU 0X8F  ;ZUM BEISPIEL          
;                                 MOVLW  STELLE-0  ;RECHTE STELLE
;                                 MOVLW  STELLE-1  ;EINS NACH LINKS ALS STELLE
;                                 CALL   BEFEHL           

;RAM-ZELLEN
;BCD21       EQU 0X01           
;BCD43       EQU 0X02
;BCD65       EQU 0X03    
;NULL_AUSB   EQU 0X05       
;MERKER      EQU 0X06
;VORZ_STELLE EQU 0X07
;VORZ_JA     EQU 0X08    ;AUS BERECHNUNGS-PROGRAMM UEBERNEHMEN ;BEI BIT0=HIGH MIT VORZEICHEN
    
;STELLE      EQU 0X89    ;ZUM BEISPIEL FUER LCD-STELLE DIE RECHTE KLEINSTE ZAHL          
           
           
BCD_ANZEIGE
           CLRF     NULL_AUSB
           CLRF     VORZ_STELLE
           
           MOVLW    STELLE-1    ;KOMMA-STELLE
           CALL     BEFEHL
           MOVLW    "."         ;ALS PUNKT
           CALL     DATEN
 
;OHNE VORNULLEN-BERECHNUNG DIE 3 RECHTEN STELLEN
           MOVLW    STELLE-0
           CALL     BEFEHL
           MOVF     BCD21, W
           ANDLW    0X0F
           ADDLW    0X30
           CALL     DATEN
           
           MOVLW    STELLE-2
           CALL     BEFEHL
           SWAPF    BCD21, W
           ANDLW    0X0F
           ADDLW    0X30
           CALL     DATEN
            
;AB DER 3-TEN STELLE ERFOLGT MIT VORNULLEN-BERECHNUNG           
;MIT DER GROESSTEN ZAHL BEGINNEN !
           MOVLW    STELLE-3
           CALL     BEFEHL
           MOVF     BCD43, W
           ANDLW    0X0F
           ADDLW    0X30
           MOVWF    MERKER
           MOVLW    0X30
           SUBWF    MERKER, W
           BTFSS    STATUS, Z
           GOTO     W01
           
           MOVLW    0X20                    ;VORNULL AUSBLENDEN
           CALL     DATEN
           MOVLW    STELLE-3
           MOVWF    VORZ_STELLE
           GOTO     VORZEICHEN
           
W01        MOVF     MERKER, W
           CALL     DATEN
           BSF      NULL_AUSB, BIT0         ;MERKER FUER NAECHSTE NULL NICHT AUSBLENDEN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
           
VORZEICHEN
           BTFSS    VORZ_JA, BIT0   ;BEI BIT0=HIGH MIT VORZEICHEN
           RETURN
           
           MOVF     VORZ_STELLE, W
           SUBLW    0X00
           BTFSC    STATUS, Z
           GOTO     VORZ01
           
           MOVF     VORZ_STELLE, W
           CALL     BEFEHL
           MOVLW    "-"
           CALL     DATEN
           RETURN
           
VORZ01     MOVLW    STELLE-4        ;VOR DER VORDERSTEN ZAHL
           CALL     BEFEHL
           MOVLW    "-"
           CALL     DATEN           
           RETURN
              
;*****************************************************************************
;*                             EEPROM WRITE                                  *
;*****************************************************************************
E_WRITE     
                MOVLB   D'3'        ;BANK3
                MOVWF   EEDATL
                MOVLB   D'0'        ;BANK0
                MOVF    ADR, W
                MOVLB   D'3'        ;BANK3
                MOVWF   EEADRL
            
                BCF     EECON1, CFGS
                BCF     EECON1, EEPGD
                BSF     EECON1, WREN
                MOVLW   0X55
                MOVWF   EECON2
                MOVLW   0XAA
                MOVWF   EECON2
                BSF     EECON1, WR
                BCF     EECON1, WREN
                
E_01            BTFSC   EECON1, WR
                GOTO    E_01
                
                MOVLB   D'0'        ;BANK0         
                RETURN
               
;*****************************************************************************
;*                             EEPROM READ                                   *
;*****************************************************************************
E_READ          MOVF    ADR, W
                MOVLB   D'3'                ;BANK3
                MOVWF   EEADRL
                BCF     EECON1, CFGS
                BCF     EECON1, EEPGD
                BSF     EECON1, RD
                MOVF    EEDATL, W
                MOVLB   D'0'                
                RETURN                            
               
           
                
                
                
                
                
                
                
            ORG 0X0800
;****************************************************************************************
;*                                                                                      *
;*                        16-BIT HEX-ZAHL IN BCD-ZAHLEN                                 *
;*                                                                                      *
;****************************************************************************************
           

;EINGABE BYTES / ALSO HEX-BYTES (16-BITS ==> FF FF)    ==> MAX.-DEZ.: 06 55 35 SIND 3STCK BCD-BYTE

;EINGABE HEX-BYTE            
;EINGABE_BYTE01   EQU  0X01
;EINGABE_BYTE02   EQU  0X02
;EINGABE_BYTE03   EQU  0X03
           
;ERGEBNIS BYTES / ALSO BCD-BYTES WIE BCD21=0X37 IST DEZ.: 37 
;BCD21        EQU  0X04           
;BCD43        EQU  0X05
;BCD65        EQU  0X06       

;HILFS-BYTES FUER HEX-BCD            
;ZAE_D0        EQU  0X0D
;ZAE_D01       EQU  0X0E  
;ZAE_D02       EQU  0X0E             
;VER           EQU  0X0F
         
           
HEX_ZU_BCD
            
    MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0800 
    MOVWF   PCLATH
    
    
            CLRF    BCD21
            CLRF    BCD43
            CLRF    BCD65
         
            BTFSS   EINGABE_BYTE01, BIT0
            GOTO    W001
            MOVLW   0X01
            MOVWF   BCD21

W001        BTFSS   EINGABE_BYTE01, BIT1
            GOTO    W002
            MOVF    BCD21, W
            ADDLW   0X02
            MOVWF   BCD21

W002        BTFSS   EINGABE_BYTE01, BIT2
            GOTO    W003
            MOVF    BCD21, W
            ADDLW   0X04
            MOVWF   BCD21

;-------

W003        BTFSS   EINGABE_BYTE01, BIT3
            GOTO    W004
            MOVLW   D'8'
            MOVWF   ZAE_D0

W003B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W003A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

W003A       DECFSZ  ZAE_D0, F
            GOTO    W003B

;--------

W004        BTFSS   EINGABE_BYTE01, BIT4
            GOTO    W005
            MOVLW   D'16'
            MOVWF   ZAE_D0

W004B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W004A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

W004A       DECFSZ  ZAE_D0, F
            GOTO    W004B

;--------

W005        BTFSS   EINGABE_BYTE01, BIT5
            GOTO    W006
            MOVLW   D'32'
            MOVWF   ZAE_D0

W005B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W005A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21 

W005A       DECFSZ  ZAE_D0, F
            GOTO    W005B

;--------

W006        BTFSS   EINGABE_BYTE01, BIT6
            GOTO    W007
            MOVLW   D'64'
            MOVWF   ZAE_D0

W006B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W006A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER 
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W006A
            CLRF    BCD21
            MOVF    BCD43, W
            ANDLW   0X0F
            ADDLW   0X01
            MOVWF   BCD43

W006A       DECFSZ  ZAE_D0, F
            GOTO    W006B

;--------

W007        BTFSS   EINGABE_BYTE01, BIT7
            GOTO    W011
            MOVLW   D'128'
            MOVWF   ZAE_D0

W007B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W007A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W007A
            CLRF    BCD21
            MOVF    BCD43, W
            ANDLW   0X0F
            ADDLW   0X01
            MOVWF   BCD43

W007A       DECFSZ  ZAE_D0, F
            GOTO    W007B
            
;--------

W011        BTFSS   EINGABE_BYTE02, BIT0 ;GEHT BIS 1FF = 5.11DEZ    
            GOTO    W012
            MOVLW   D'2'
            MOVWF   ZAE_D01
W011C       MOVLW   D'128'
            MOVWF   ZAE_D0
            
W011B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W011A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W011A
            CLRF    BCD21
            MOVF    BCD43, W
            ANDLW   0X0F
            ADDLW   0X01
            MOVWF   BCD43
                        
W011A       DECFSZ  ZAE_D0, F
            GOTO    W011B

            DECFSZ  ZAE_D01, F
            GOTO    W011C
                   
;--------

W012        BTFSS   EINGABE_BYTE02, BIT1 ;GEHT BIS 3FF = 10.23DEZ 
            GOTO    W013
            MOVLW   D'4'
            MOVWF   ZAE_D01
W012C       MOVLW   D'128'
            MOVWF   ZAE_D0
            
W012B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W012A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W012A
            CLRF    BCD21
            MOVF    BCD43, W
            ADDLW   0X01
            MOVWF   BCD43
            
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W012A
            MOVF    BCD43, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD43
                        
W012A       DECFSZ  ZAE_D0, F
            GOTO    W012B

            DECFSZ  ZAE_D01, F
            GOTO    W012C
                  
;--------
;--------            
W013        BTFSS   EINGABE_BYTE02, BIT2 ;GEHT 7FF = 20.47DEZ 
            GOTO    W014
            MOVLW   D'8'
            MOVWF   ZAE_D01
W013C       MOVLW   D'128'
            MOVWF   ZAE_D0
            
W013B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W013A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W013A
            CLRF    BCD21
            MOVF    BCD43, W
            ADDLW   0X01
            MOVWF   BCD43
            
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W013A
            ;CLRF    BCD21
            MOVF    BCD43, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD43
                        
W013A       DECFSZ  ZAE_D0, F
            GOTO    W013B

            DECFSZ  ZAE_D01, F
            GOTO    W013C
                  
;--------
;--------

W014        BTFSS   EINGABE_BYTE02, BIT3
            GOTO    W015
            MOVLW   D'16'
            MOVWF   ZAE_D01
W014C       MOVLW   D'128'
            MOVWF   ZAE_D0
             
W014B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W014A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W014A
            CLRF    BCD21
            MOVF    BCD43, W
            ADDLW   0X01
            MOVWF   BCD43
            
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W014A
            MOVF    BCD43, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD43
                        
W014A       DECFSZ  ZAE_D0, F
            GOTO    W014B

            DECFSZ  ZAE_D01, F
            GOTO    W014C
  
;--------
;--------
            
W015        BTFSS   EINGABE_BYTE02, BIT4   ;1FFF = 8191 GEHT
            GOTO    W016
            MOVLW   D'32'
            MOVWF   ZAE_D01
W015C       MOVLW   D'128'
            MOVWF   ZAE_D0

             
W015B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W015A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W015A
            CLRF    BCD21
            MOVF    BCD43, W
            ADDLW   0X01
            MOVWF   BCD43
            
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W015A
            MOVF    BCD43, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD43
                        
W015A       DECFSZ  ZAE_D0, F
            GOTO    W015B

            DECFSZ  ZAE_D01, F
            GOTO    W015C
      
;--------
;--------            

W016        BTFSS   EINGABE_BYTE02, BIT5   ;MAX.: 3F FF = 1 63 83
            GOTO    W017
            MOVLW   D'64'
            MOVWF   ZAE_D01
W016C       MOVLW   D'128'
            MOVWF   ZAE_D0
 
             
W016B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W016A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W016A
            CLRF    BCD21
            MOVF    BCD43, W
            ADDLW   0X01
            MOVWF   BCD43
            
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W016A
            MOVF    BCD43, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD43
            
            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W016A
            CLRF    BCD21
            CLRF    BCD43
            MOVF    BCD65, W
            ADDLW   0X01
            MOVWF   BCD65
            
W016A       DECFSZ  ZAE_D0, F
            GOTO    W016B

            DECFSZ  ZAE_D01, F
            GOTO    W016C
      
;--------            
;--------

W017        BTFSS   EINGABE_BYTE02, BIT6   ;MAX.: 7F FF = 3 27 67
            GOTO    W018
            MOVLW   D'128'
            MOVWF   ZAE_D01
W017C       MOVLW   D'128'
            MOVWF   ZAE_D0
            
W017B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W017A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W017A
            CLRF    BCD21
            MOVF    BCD43, W
            ADDLW   0X01
            MOVWF   BCD43
            
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W017A
            MOVF    BCD43, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD43
            
            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W017A
            CLRF    BCD21
            CLRF    BCD43
            MOVF    BCD65, W
            ADDLW   0X01
            MOVWF   BCD65
     
W017A       DECFSZ  ZAE_D0, F
            GOTO    W017B

            DECFSZ  ZAE_D01, F
            GOTO    W017C
          
;--------
;--------
            
W018        BTFSS   EINGABE_BYTE02, BIT7   ;MAX.: FF FF = 6 55 35
            RETURN ;GOTO    W019
            MOVLW   D'2'                ;2*128*128   = 3 27 68    DER REST FEHLT VON OBEN
            MOVWF   ZAE_D02
W018D       MOVLW   D'128'
            MOVWF   ZAE_D01
W018C       MOVLW   D'128'
            MOVWF   ZAE_D0
            
W018B       INCF    BCD21, F
            MOVF    BCD21, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W018A
            MOVF    BCD21, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD21

            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W018A
            CLRF    BCD21
            MOVF    BCD43, W
            ADDLW   0X01
            MOVWF   BCD43
            
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W018A
            MOVF    BCD43, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   BCD43
            
            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W018A
            CLRF    BCD21
            CLRF    BCD43
            MOVF    BCD65, W
            ADDLW   0X01
            MOVWF   BCD65
            
W018A       DECFSZ  ZAE_D0, F
            GOTO    W018B

            DECFSZ  ZAE_D01, F
            GOTO    W018C
            
            DECFSZ  ZAE_D02, F
            GOTO    W018D
            
            RETURN
;--------         
;--------
     
    
    
    
                        END

           
 